// services/network/public/mojom/trust_tokens.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_TRUST_TOKENS_MOJOM_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_TRUST_TOKENS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/network/public/mojom/trust_tokens.mojom-shared.h"
#include "services/network/public/mojom/trust_tokens.mojom-forward.h"
#include "url/mojom/origin.mojom.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace network {
namespace mojom {

class HasTrustTokensAnswererProxy;

template <typename ImplRefTraits>
class HasTrustTokensAnswererStub;

class HasTrustTokensAnswererRequestValidator;
class HasTrustTokensAnswererResponseValidator;


class  HasTrustTokensAnswerer
    : public HasTrustTokensAnswererInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = HasTrustTokensAnswererInterfaceBase;
  using Proxy_ = HasTrustTokensAnswererProxy;

  template <typename ImplRefTraits>
  using Stub_ = HasTrustTokensAnswererStub<ImplRefTraits>;

  using RequestValidator_ = HasTrustTokensAnswererRequestValidator;
  using ResponseValidator_ = HasTrustTokensAnswererResponseValidator;
  enum MethodMinVersions : uint32_t {
    kHasTrustTokensMinVersion = 0,
  };
  virtual ~HasTrustTokensAnswerer() {}


  using HasTrustTokensCallback = base::OnceCallback<void(HasTrustTokensResultPtr)>;
  
  virtual void HasTrustTokens(const ::url::Origin& issuer, HasTrustTokensCallback callback) = 0;
};



class  HasTrustTokensAnswererProxy
    : public HasTrustTokensAnswerer {
 public:
  using InterfaceType = HasTrustTokensAnswerer;

  explicit HasTrustTokensAnswererProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void HasTrustTokens(const ::url::Origin& issuer, HasTrustTokensCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  HasTrustTokensAnswererStubDispatch {
 public:
  static bool Accept(HasTrustTokensAnswerer* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      HasTrustTokensAnswerer* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<HasTrustTokensAnswerer>>
class HasTrustTokensAnswererStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  HasTrustTokensAnswererStub() {}
  ~HasTrustTokensAnswererStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return HasTrustTokensAnswererStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return HasTrustTokensAnswererStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  HasTrustTokensAnswererRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  HasTrustTokensAnswererResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};






class  HasTrustTokensResult {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<HasTrustTokensResult, T>::value>;
  using DataView = HasTrustTokensResultDataView;
  using Data_ = internal::HasTrustTokensResult_Data;

  template <typename... Args>
  static HasTrustTokensResultPtr New(Args&&... args) {
    return HasTrustTokensResultPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static HasTrustTokensResultPtr From(const U& u) {
    return mojo::TypeConverter<HasTrustTokensResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, HasTrustTokensResult>::Convert(*this);
  }


  HasTrustTokensResult();

  HasTrustTokensResult(
      TrustTokenOperationStatus status,
      bool has_trust_tokens);

  ~HasTrustTokensResult();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = HasTrustTokensResultPtr>
  HasTrustTokensResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, HasTrustTokensResult::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        HasTrustTokensResult::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        HasTrustTokensResult::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::HasTrustTokensResult_UnserializedMessageContext<
            UserType, HasTrustTokensResult::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<HasTrustTokensResult::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return HasTrustTokensResult::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::HasTrustTokensResult_UnserializedMessageContext<
            UserType, HasTrustTokensResult::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<HasTrustTokensResult::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  TrustTokenOperationStatus status;
  
  bool has_trust_tokens;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, HasTrustTokensResult::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, HasTrustTokensResult::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, HasTrustTokensResult::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, HasTrustTokensResult::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  TrustTokenKeyCommitmentBatchSize {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<TrustTokenKeyCommitmentBatchSize, T>::value>;
  using DataView = TrustTokenKeyCommitmentBatchSizeDataView;
  using Data_ = internal::TrustTokenKeyCommitmentBatchSize_Data;

  template <typename... Args>
  static TrustTokenKeyCommitmentBatchSizePtr New(Args&&... args) {
    return TrustTokenKeyCommitmentBatchSizePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TrustTokenKeyCommitmentBatchSizePtr From(const U& u) {
    return mojo::TypeConverter<TrustTokenKeyCommitmentBatchSizePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TrustTokenKeyCommitmentBatchSize>::Convert(*this);
  }


  TrustTokenKeyCommitmentBatchSize();

  explicit TrustTokenKeyCommitmentBatchSize(
      int32_t value);

  ~TrustTokenKeyCommitmentBatchSize();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TrustTokenKeyCommitmentBatchSizePtr>
  TrustTokenKeyCommitmentBatchSizePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, TrustTokenKeyCommitmentBatchSize::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        TrustTokenKeyCommitmentBatchSize::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TrustTokenKeyCommitmentBatchSize::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::TrustTokenKeyCommitmentBatchSize_UnserializedMessageContext<
            UserType, TrustTokenKeyCommitmentBatchSize::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<TrustTokenKeyCommitmentBatchSize::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return TrustTokenKeyCommitmentBatchSize::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::TrustTokenKeyCommitmentBatchSize_UnserializedMessageContext<
            UserType, TrustTokenKeyCommitmentBatchSize::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<TrustTokenKeyCommitmentBatchSize::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  int32_t value;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, TrustTokenKeyCommitmentBatchSize::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, TrustTokenKeyCommitmentBatchSize::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, TrustTokenKeyCommitmentBatchSize::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, TrustTokenKeyCommitmentBatchSize::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}








class  TrustTokenParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<TrustTokenParams, T>::value>;
  using DataView = TrustTokenParamsDataView;
  using Data_ = internal::TrustTokenParams_Data;

  template <typename... Args>
  static TrustTokenParamsPtr New(Args&&... args) {
    return TrustTokenParamsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TrustTokenParamsPtr From(const U& u) {
    return mojo::TypeConverter<TrustTokenParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TrustTokenParams>::Convert(*this);
  }


  TrustTokenParams();

  TrustTokenParams(
      TrustTokenOperationType type,
      TrustTokenRefreshPolicy refresh_policy,
      TrustTokenSignRequestData sign_request_data,
      bool include_timestamp_header,
      const base::Optional<::url::Origin>& issuer,
      std::vector<std::string> additional_signed_headers);

  ~TrustTokenParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TrustTokenParamsPtr>
  TrustTokenParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, TrustTokenParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        TrustTokenParams::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TrustTokenParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::TrustTokenParams_UnserializedMessageContext<
            UserType, TrustTokenParams::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<TrustTokenParams::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return TrustTokenParams::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::TrustTokenParams_UnserializedMessageContext<
            UserType, TrustTokenParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<TrustTokenParams::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  TrustTokenOperationType type;
  
  TrustTokenRefreshPolicy refresh_policy;
  
  TrustTokenSignRequestData sign_request_data;
  
  bool include_timestamp_header;
  
  base::Optional<::url::Origin> issuer;
  
  std::vector<std::string> additional_signed_headers;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, TrustTokenParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, TrustTokenParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, TrustTokenParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, TrustTokenParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  TrustTokenVerificationKey {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<TrustTokenVerificationKey, T>::value>;
  using DataView = TrustTokenVerificationKeyDataView;
  using Data_ = internal::TrustTokenVerificationKey_Data;

  template <typename... Args>
  static TrustTokenVerificationKeyPtr New(Args&&... args) {
    return TrustTokenVerificationKeyPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TrustTokenVerificationKeyPtr From(const U& u) {
    return mojo::TypeConverter<TrustTokenVerificationKeyPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TrustTokenVerificationKey>::Convert(*this);
  }


  TrustTokenVerificationKey();

  TrustTokenVerificationKey(
      const std::string& body,
      ::base::Time expiry,
      uint32_t label);

  ~TrustTokenVerificationKey();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TrustTokenVerificationKeyPtr>
  TrustTokenVerificationKeyPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, TrustTokenVerificationKey::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        TrustTokenVerificationKey::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TrustTokenVerificationKey::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::TrustTokenVerificationKey_UnserializedMessageContext<
            UserType, TrustTokenVerificationKey::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<TrustTokenVerificationKey::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return TrustTokenVerificationKey::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::TrustTokenVerificationKey_UnserializedMessageContext<
            UserType, TrustTokenVerificationKey::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<TrustTokenVerificationKey::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string body;
  
  ::base::Time expiry;
  
  uint32_t label;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, TrustTokenVerificationKey::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, TrustTokenVerificationKey::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, TrustTokenVerificationKey::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, TrustTokenVerificationKey::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  TrustTokenKeyCommitmentResult {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<TrustTokenKeyCommitmentResult, T>::value>;
  using DataView = TrustTokenKeyCommitmentResultDataView;
  using Data_ = internal::TrustTokenKeyCommitmentResult_Data;

  template <typename... Args>
  static TrustTokenKeyCommitmentResultPtr New(Args&&... args) {
    return TrustTokenKeyCommitmentResultPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TrustTokenKeyCommitmentResultPtr From(const U& u) {
    return mojo::TypeConverter<TrustTokenKeyCommitmentResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TrustTokenKeyCommitmentResult>::Convert(*this);
  }


  TrustTokenKeyCommitmentResult();

  TrustTokenKeyCommitmentResult(
      TrustTokenKeyCommitmentBatchSizePtr batch_size,
      std::vector<TrustTokenVerificationKeyPtr> keys,
      const std::string& signed_redemption_record_verification_key);

  ~TrustTokenKeyCommitmentResult();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TrustTokenKeyCommitmentResultPtr>
  TrustTokenKeyCommitmentResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, TrustTokenKeyCommitmentResult::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        TrustTokenKeyCommitmentResult::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TrustTokenKeyCommitmentResult::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::TrustTokenKeyCommitmentResult_UnserializedMessageContext<
            UserType, TrustTokenKeyCommitmentResult::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<TrustTokenKeyCommitmentResult::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return TrustTokenKeyCommitmentResult::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::TrustTokenKeyCommitmentResult_UnserializedMessageContext<
            UserType, TrustTokenKeyCommitmentResult::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<TrustTokenKeyCommitmentResult::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  TrustTokenKeyCommitmentBatchSizePtr batch_size;
  
  std::vector<TrustTokenVerificationKeyPtr> keys;
  
  std::string signed_redemption_record_verification_key;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(TrustTokenKeyCommitmentResult);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, TrustTokenKeyCommitmentResult::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, TrustTokenKeyCommitmentResult::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, TrustTokenKeyCommitmentResult::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, TrustTokenKeyCommitmentResult::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
TrustTokenParamsPtr TrustTokenParams::Clone() const {
  return New(
      mojo::Clone(type),
      mojo::Clone(refresh_policy),
      mojo::Clone(sign_request_data),
      mojo::Clone(include_timestamp_header),
      mojo::Clone(issuer),
      mojo::Clone(additional_signed_headers)
  );
}

template <typename T, TrustTokenParams::EnableIfSame<T>*>
bool TrustTokenParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->refresh_policy, other_struct.refresh_policy))
    return false;
  if (!mojo::Equals(this->sign_request_data, other_struct.sign_request_data))
    return false;
  if (!mojo::Equals(this->include_timestamp_header, other_struct.include_timestamp_header))
    return false;
  if (!mojo::Equals(this->issuer, other_struct.issuer))
    return false;
  if (!mojo::Equals(this->additional_signed_headers, other_struct.additional_signed_headers))
    return false;
  return true;
}

template <typename T, TrustTokenParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<decltype(lhs.type)>(lhs.type, rhs.type))
    return true;
  if (std::less<decltype(lhs.type)>(rhs.type, lhs.type))
    return false;
  if (std::less<decltype(lhs.refresh_policy)>(lhs.refresh_policy, rhs.refresh_policy))
    return true;
  if (std::less<decltype(lhs.refresh_policy)>(rhs.refresh_policy, lhs.refresh_policy))
    return false;
  if (std::less<decltype(lhs.sign_request_data)>(lhs.sign_request_data, rhs.sign_request_data))
    return true;
  if (std::less<decltype(lhs.sign_request_data)>(rhs.sign_request_data, lhs.sign_request_data))
    return false;
  if (std::less<decltype(lhs.include_timestamp_header)>(lhs.include_timestamp_header, rhs.include_timestamp_header))
    return true;
  if (std::less<decltype(lhs.include_timestamp_header)>(rhs.include_timestamp_header, lhs.include_timestamp_header))
    return false;
  if (std::less<decltype(lhs.issuer)>(lhs.issuer, rhs.issuer))
    return true;
  if (std::less<decltype(lhs.issuer)>(rhs.issuer, lhs.issuer))
    return false;
  if (std::less<decltype(lhs.additional_signed_headers)>(lhs.additional_signed_headers, rhs.additional_signed_headers))
    return true;
  if (std::less<decltype(lhs.additional_signed_headers)>(rhs.additional_signed_headers, lhs.additional_signed_headers))
    return false;
  return false;
}
template <typename StructPtrType>
HasTrustTokensResultPtr HasTrustTokensResult::Clone() const {
  return New(
      mojo::Clone(status),
      mojo::Clone(has_trust_tokens)
  );
}

template <typename T, HasTrustTokensResult::EnableIfSame<T>*>
bool HasTrustTokensResult::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->status, other_struct.status))
    return false;
  if (!mojo::Equals(this->has_trust_tokens, other_struct.has_trust_tokens))
    return false;
  return true;
}

template <typename T, HasTrustTokensResult::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<decltype(lhs.status)>(lhs.status, rhs.status))
    return true;
  if (std::less<decltype(lhs.status)>(rhs.status, lhs.status))
    return false;
  if (std::less<decltype(lhs.has_trust_tokens)>(lhs.has_trust_tokens, rhs.has_trust_tokens))
    return true;
  if (std::less<decltype(lhs.has_trust_tokens)>(rhs.has_trust_tokens, lhs.has_trust_tokens))
    return false;
  return false;
}
template <typename StructPtrType>
TrustTokenVerificationKeyPtr TrustTokenVerificationKey::Clone() const {
  return New(
      mojo::Clone(body),
      mojo::Clone(expiry),
      mojo::Clone(label)
  );
}

template <typename T, TrustTokenVerificationKey::EnableIfSame<T>*>
bool TrustTokenVerificationKey::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->body, other_struct.body))
    return false;
  if (!mojo::Equals(this->expiry, other_struct.expiry))
    return false;
  if (!mojo::Equals(this->label, other_struct.label))
    return false;
  return true;
}

template <typename T, TrustTokenVerificationKey::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<decltype(lhs.body)>(lhs.body, rhs.body))
    return true;
  if (std::less<decltype(lhs.body)>(rhs.body, lhs.body))
    return false;
  if (std::less<decltype(lhs.expiry)>(lhs.expiry, rhs.expiry))
    return true;
  if (std::less<decltype(lhs.expiry)>(rhs.expiry, lhs.expiry))
    return false;
  if (std::less<decltype(lhs.label)>(lhs.label, rhs.label))
    return true;
  if (std::less<decltype(lhs.label)>(rhs.label, lhs.label))
    return false;
  return false;
}
template <typename StructPtrType>
TrustTokenKeyCommitmentBatchSizePtr TrustTokenKeyCommitmentBatchSize::Clone() const {
  return New(
      mojo::Clone(value)
  );
}

template <typename T, TrustTokenKeyCommitmentBatchSize::EnableIfSame<T>*>
bool TrustTokenKeyCommitmentBatchSize::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  return true;
}

template <typename T, TrustTokenKeyCommitmentBatchSize::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<decltype(lhs.value)>(lhs.value, rhs.value))
    return true;
  if (std::less<decltype(lhs.value)>(rhs.value, lhs.value))
    return false;
  return false;
}
template <typename StructPtrType>
TrustTokenKeyCommitmentResultPtr TrustTokenKeyCommitmentResult::Clone() const {
  return New(
      mojo::Clone(batch_size),
      mojo::Clone(keys),
      mojo::Clone(signed_redemption_record_verification_key)
  );
}

template <typename T, TrustTokenKeyCommitmentResult::EnableIfSame<T>*>
bool TrustTokenKeyCommitmentResult::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->batch_size, other_struct.batch_size))
    return false;
  if (!mojo::Equals(this->keys, other_struct.keys))
    return false;
  if (!mojo::Equals(this->signed_redemption_record_verification_key, other_struct.signed_redemption_record_verification_key))
    return false;
  return true;
}

template <typename T, TrustTokenKeyCommitmentResult::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<decltype(lhs.batch_size)>(lhs.batch_size, rhs.batch_size))
    return true;
  if (std::less<decltype(lhs.batch_size)>(rhs.batch_size, lhs.batch_size))
    return false;
  if (std::less<decltype(lhs.keys)>(lhs.keys, rhs.keys))
    return true;
  if (std::less<decltype(lhs.keys)>(rhs.keys, lhs.keys))
    return false;
  if (std::less<decltype(lhs.signed_redemption_record_verification_key)>(lhs.signed_redemption_record_verification_key, rhs.signed_redemption_record_verification_key))
    return true;
  if (std::less<decltype(lhs.signed_redemption_record_verification_key)>(rhs.signed_redemption_record_verification_key, lhs.signed_redemption_record_verification_key))
    return false;
  return false;
}


}  // namespace mojom
}  // namespace network

namespace mojo {


template <>
struct  StructTraits<::network::mojom::TrustTokenParams::DataView,
                                         ::network::mojom::TrustTokenParamsPtr> {
  static bool IsNull(const ::network::mojom::TrustTokenParamsPtr& input) { return !input; }
  static void SetToNull(::network::mojom::TrustTokenParamsPtr* output) { output->reset(); }

  static decltype(::network::mojom::TrustTokenParams::type) type(
      const ::network::mojom::TrustTokenParamsPtr& input) {
    return input->type;
  }

  static decltype(::network::mojom::TrustTokenParams::refresh_policy) refresh_policy(
      const ::network::mojom::TrustTokenParamsPtr& input) {
    return input->refresh_policy;
  }

  static decltype(::network::mojom::TrustTokenParams::sign_request_data) sign_request_data(
      const ::network::mojom::TrustTokenParamsPtr& input) {
    return input->sign_request_data;
  }

  static decltype(::network::mojom::TrustTokenParams::include_timestamp_header) include_timestamp_header(
      const ::network::mojom::TrustTokenParamsPtr& input) {
    return input->include_timestamp_header;
  }

  static const decltype(::network::mojom::TrustTokenParams::issuer)& issuer(
      const ::network::mojom::TrustTokenParamsPtr& input) {
    return input->issuer;
  }

  static const decltype(::network::mojom::TrustTokenParams::additional_signed_headers)& additional_signed_headers(
      const ::network::mojom::TrustTokenParamsPtr& input) {
    return input->additional_signed_headers;
  }

  static bool Read(::network::mojom::TrustTokenParams::DataView input, ::network::mojom::TrustTokenParamsPtr* output);
};


template <>
struct  StructTraits<::network::mojom::HasTrustTokensResult::DataView,
                                         ::network::mojom::HasTrustTokensResultPtr> {
  static bool IsNull(const ::network::mojom::HasTrustTokensResultPtr& input) { return !input; }
  static void SetToNull(::network::mojom::HasTrustTokensResultPtr* output) { output->reset(); }

  static decltype(::network::mojom::HasTrustTokensResult::status) status(
      const ::network::mojom::HasTrustTokensResultPtr& input) {
    return input->status;
  }

  static decltype(::network::mojom::HasTrustTokensResult::has_trust_tokens) has_trust_tokens(
      const ::network::mojom::HasTrustTokensResultPtr& input) {
    return input->has_trust_tokens;
  }

  static bool Read(::network::mojom::HasTrustTokensResult::DataView input, ::network::mojom::HasTrustTokensResultPtr* output);
};


template <>
struct  StructTraits<::network::mojom::TrustTokenVerificationKey::DataView,
                                         ::network::mojom::TrustTokenVerificationKeyPtr> {
  static bool IsNull(const ::network::mojom::TrustTokenVerificationKeyPtr& input) { return !input; }
  static void SetToNull(::network::mojom::TrustTokenVerificationKeyPtr* output) { output->reset(); }

  static const decltype(::network::mojom::TrustTokenVerificationKey::body)& body(
      const ::network::mojom::TrustTokenVerificationKeyPtr& input) {
    return input->body;
  }

  static const decltype(::network::mojom::TrustTokenVerificationKey::expiry)& expiry(
      const ::network::mojom::TrustTokenVerificationKeyPtr& input) {
    return input->expiry;
  }

  static decltype(::network::mojom::TrustTokenVerificationKey::label) label(
      const ::network::mojom::TrustTokenVerificationKeyPtr& input) {
    return input->label;
  }

  static bool Read(::network::mojom::TrustTokenVerificationKey::DataView input, ::network::mojom::TrustTokenVerificationKeyPtr* output);
};


template <>
struct  StructTraits<::network::mojom::TrustTokenKeyCommitmentBatchSize::DataView,
                                         ::network::mojom::TrustTokenKeyCommitmentBatchSizePtr> {
  static bool IsNull(const ::network::mojom::TrustTokenKeyCommitmentBatchSizePtr& input) { return !input; }
  static void SetToNull(::network::mojom::TrustTokenKeyCommitmentBatchSizePtr* output) { output->reset(); }

  static decltype(::network::mojom::TrustTokenKeyCommitmentBatchSize::value) value(
      const ::network::mojom::TrustTokenKeyCommitmentBatchSizePtr& input) {
    return input->value;
  }

  static bool Read(::network::mojom::TrustTokenKeyCommitmentBatchSize::DataView input, ::network::mojom::TrustTokenKeyCommitmentBatchSizePtr* output);
};


template <>
struct  StructTraits<::network::mojom::TrustTokenKeyCommitmentResult::DataView,
                                         ::network::mojom::TrustTokenKeyCommitmentResultPtr> {
  static bool IsNull(const ::network::mojom::TrustTokenKeyCommitmentResultPtr& input) { return !input; }
  static void SetToNull(::network::mojom::TrustTokenKeyCommitmentResultPtr* output) { output->reset(); }

  static const decltype(::network::mojom::TrustTokenKeyCommitmentResult::batch_size)& batch_size(
      const ::network::mojom::TrustTokenKeyCommitmentResultPtr& input) {
    return input->batch_size;
  }

  static const decltype(::network::mojom::TrustTokenKeyCommitmentResult::keys)& keys(
      const ::network::mojom::TrustTokenKeyCommitmentResultPtr& input) {
    return input->keys;
  }

  static const decltype(::network::mojom::TrustTokenKeyCommitmentResult::signed_redemption_record_verification_key)& signed_redemption_record_verification_key(
      const ::network::mojom::TrustTokenKeyCommitmentResultPtr& input) {
    return input->signed_redemption_record_verification_key;
  }

  static bool Read(::network::mojom::TrustTokenKeyCommitmentResult::DataView input, ::network::mojom::TrustTokenKeyCommitmentResultPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_TRUST_TOKENS_MOJOM_H_