// third_party/blink/public/mojom/devtools/inspector_issue.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_DEVTOOLS_INSPECTOR_ISSUE_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_DEVTOOLS_INSPECTOR_ISSUE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/devtools/inspector_issue.mojom-shared.h"
#include "third_party/blink/public/mojom/devtools/inspector_issue.mojom-forward.h"
#include "url/mojom/url.mojom.h"
#include "services/network/public/mojom/cookie_manager.mojom.h"
#include <string>
#include <vector>




#include "third_party/blink/public/common/common_export.h"




namespace blink {
namespace mojom {












class BLINK_COMMON_EXPORT AffectedCookie {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AffectedCookie, T>::value>;
  using DataView = AffectedCookieDataView;
  using Data_ = internal::AffectedCookie_Data;

  template <typename... Args>
  static AffectedCookiePtr New(Args&&... args) {
    return AffectedCookiePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AffectedCookiePtr From(const U& u) {
    return mojo::TypeConverter<AffectedCookiePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AffectedCookie>::Convert(*this);
  }


  AffectedCookie();

  AffectedCookie(
      const std::string& name,
      const std::string& path,
      const std::string& domain,
      const base::Optional<::GURL>& site_for_cookies);

  ~AffectedCookie();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AffectedCookiePtr>
  AffectedCookiePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AffectedCookie::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AffectedCookie::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AffectedCookie::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AffectedCookie_UnserializedMessageContext<
            UserType, AffectedCookie::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<AffectedCookie::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return AffectedCookie::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AffectedCookie_UnserializedMessageContext<
            UserType, AffectedCookie::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AffectedCookie::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string name;
  
  std::string path;
  
  std::string domain;
  
  base::Optional<::GURL> site_for_cookies;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AffectedCookie::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AffectedCookie::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AffectedCookie::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AffectedCookie::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT AffectedResources {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AffectedResources, T>::value>;
  using DataView = AffectedResourcesDataView;
  using Data_ = internal::AffectedResources_Data;

  template <typename... Args>
  static AffectedResourcesPtr New(Args&&... args) {
    return AffectedResourcesPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AffectedResourcesPtr From(const U& u) {
    return mojo::TypeConverter<AffectedResourcesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AffectedResources>::Convert(*this);
  }


  AffectedResources();

  explicit AffectedResources(
      std::vector<AffectedCookiePtr> cookies);

  ~AffectedResources();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AffectedResourcesPtr>
  AffectedResourcesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AffectedResources::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AffectedResources::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AffectedResources::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AffectedResources_UnserializedMessageContext<
            UserType, AffectedResources::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<AffectedResources::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return AffectedResources::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AffectedResources_UnserializedMessageContext<
            UserType, AffectedResources::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AffectedResources::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::vector<AffectedCookiePtr> cookies;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(AffectedResources);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AffectedResources::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AffectedResources::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AffectedResources::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AffectedResources::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT SameSiteCookieIssueDetails {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SameSiteCookieIssueDetails, T>::value>;
  using DataView = SameSiteCookieIssueDetailsDataView;
  using Data_ = internal::SameSiteCookieIssueDetails_Data;

  template <typename... Args>
  static SameSiteCookieIssueDetailsPtr New(Args&&... args) {
    return SameSiteCookieIssueDetailsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SameSiteCookieIssueDetailsPtr From(const U& u) {
    return mojo::TypeConverter<SameSiteCookieIssueDetailsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SameSiteCookieIssueDetails>::Convert(*this);
  }


  SameSiteCookieIssueDetails();

  SameSiteCookieIssueDetails(
      std::vector<SameSiteCookieExclusionReason> exclusionReason,
      std::vector<SameSiteCookieWarningReason> warningReason);

  ~SameSiteCookieIssueDetails();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SameSiteCookieIssueDetailsPtr>
  SameSiteCookieIssueDetailsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SameSiteCookieIssueDetails::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SameSiteCookieIssueDetails::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SameSiteCookieIssueDetails::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SameSiteCookieIssueDetails_UnserializedMessageContext<
            UserType, SameSiteCookieIssueDetails::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<SameSiteCookieIssueDetails::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return SameSiteCookieIssueDetails::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SameSiteCookieIssueDetails_UnserializedMessageContext<
            UserType, SameSiteCookieIssueDetails::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SameSiteCookieIssueDetails::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::vector<SameSiteCookieExclusionReason> exclusionReason;
  
  std::vector<SameSiteCookieWarningReason> warningReason;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SameSiteCookieIssueDetails::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SameSiteCookieIssueDetails::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SameSiteCookieIssueDetails::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SameSiteCookieIssueDetails::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT InspectorIssueDetails {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<InspectorIssueDetails, T>::value>;
  using DataView = InspectorIssueDetailsDataView;
  using Data_ = internal::InspectorIssueDetails_Data;

  template <typename... Args>
  static InspectorIssueDetailsPtr New(Args&&... args) {
    return InspectorIssueDetailsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static InspectorIssueDetailsPtr From(const U& u) {
    return mojo::TypeConverter<InspectorIssueDetailsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, InspectorIssueDetails>::Convert(*this);
  }


  InspectorIssueDetails();

  explicit InspectorIssueDetails(
      SameSiteCookieIssueDetailsPtr sameSiteCookieIssueDetails);

  ~InspectorIssueDetails();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = InspectorIssueDetailsPtr>
  InspectorIssueDetailsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, InspectorIssueDetails::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        InspectorIssueDetails::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        InspectorIssueDetails::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::InspectorIssueDetails_UnserializedMessageContext<
            UserType, InspectorIssueDetails::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<InspectorIssueDetails::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return InspectorIssueDetails::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::InspectorIssueDetails_UnserializedMessageContext<
            UserType, InspectorIssueDetails::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<InspectorIssueDetails::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  SameSiteCookieIssueDetailsPtr sameSiteCookieIssueDetails;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(InspectorIssueDetails);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, InspectorIssueDetails::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, InspectorIssueDetails::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, InspectorIssueDetails::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, InspectorIssueDetails::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT InspectorIssueInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<InspectorIssueInfo, T>::value>;
  using DataView = InspectorIssueInfoDataView;
  using Data_ = internal::InspectorIssueInfo_Data;

  template <typename... Args>
  static InspectorIssueInfoPtr New(Args&&... args) {
    return InspectorIssueInfoPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static InspectorIssueInfoPtr From(const U& u) {
    return mojo::TypeConverter<InspectorIssueInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, InspectorIssueInfo>::Convert(*this);
  }


  InspectorIssueInfo();

  InspectorIssueInfo(
      InspectorIssueCode code,
      InspectorIssueDetailsPtr details,
      AffectedResourcesPtr resources);

  ~InspectorIssueInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = InspectorIssueInfoPtr>
  InspectorIssueInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, InspectorIssueInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        InspectorIssueInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        InspectorIssueInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::InspectorIssueInfo_UnserializedMessageContext<
            UserType, InspectorIssueInfo::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<InspectorIssueInfo::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return InspectorIssueInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::InspectorIssueInfo_UnserializedMessageContext<
            UserType, InspectorIssueInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<InspectorIssueInfo::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  InspectorIssueCode code;
  
  InspectorIssueDetailsPtr details;
  
  AffectedResourcesPtr resources;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(InspectorIssueInfo);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, InspectorIssueInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, InspectorIssueInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, InspectorIssueInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, InspectorIssueInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
AffectedCookiePtr AffectedCookie::Clone() const {
  return New(
      mojo::Clone(name),
      mojo::Clone(path),
      mojo::Clone(domain),
      mojo::Clone(site_for_cookies)
  );
}

template <typename T, AffectedCookie::EnableIfSame<T>*>
bool AffectedCookie::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->path, other_struct.path))
    return false;
  if (!mojo::Equals(this->domain, other_struct.domain))
    return false;
  if (!mojo::Equals(this->site_for_cookies, other_struct.site_for_cookies))
    return false;
  return true;
}

template <typename T, AffectedCookie::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<decltype(lhs.name)>(lhs.name, rhs.name))
    return true;
  if (std::less<decltype(lhs.name)>(rhs.name, lhs.name))
    return false;
  if (std::less<decltype(lhs.path)>(lhs.path, rhs.path))
    return true;
  if (std::less<decltype(lhs.path)>(rhs.path, lhs.path))
    return false;
  if (std::less<decltype(lhs.domain)>(lhs.domain, rhs.domain))
    return true;
  if (std::less<decltype(lhs.domain)>(rhs.domain, lhs.domain))
    return false;
  if (std::less<decltype(lhs.site_for_cookies)>(lhs.site_for_cookies, rhs.site_for_cookies))
    return true;
  if (std::less<decltype(lhs.site_for_cookies)>(rhs.site_for_cookies, lhs.site_for_cookies))
    return false;
  return false;
}
template <typename StructPtrType>
AffectedResourcesPtr AffectedResources::Clone() const {
  return New(
      mojo::Clone(cookies)
  );
}

template <typename T, AffectedResources::EnableIfSame<T>*>
bool AffectedResources::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->cookies, other_struct.cookies))
    return false;
  return true;
}

template <typename T, AffectedResources::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<decltype(lhs.cookies)>(lhs.cookies, rhs.cookies))
    return true;
  if (std::less<decltype(lhs.cookies)>(rhs.cookies, lhs.cookies))
    return false;
  return false;
}
template <typename StructPtrType>
SameSiteCookieIssueDetailsPtr SameSiteCookieIssueDetails::Clone() const {
  return New(
      mojo::Clone(exclusionReason),
      mojo::Clone(warningReason)
  );
}

template <typename T, SameSiteCookieIssueDetails::EnableIfSame<T>*>
bool SameSiteCookieIssueDetails::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->exclusionReason, other_struct.exclusionReason))
    return false;
  if (!mojo::Equals(this->warningReason, other_struct.warningReason))
    return false;
  return true;
}

template <typename T, SameSiteCookieIssueDetails::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<decltype(lhs.exclusionReason)>(lhs.exclusionReason, rhs.exclusionReason))
    return true;
  if (std::less<decltype(lhs.exclusionReason)>(rhs.exclusionReason, lhs.exclusionReason))
    return false;
  if (std::less<decltype(lhs.warningReason)>(lhs.warningReason, rhs.warningReason))
    return true;
  if (std::less<decltype(lhs.warningReason)>(rhs.warningReason, lhs.warningReason))
    return false;
  return false;
}
template <typename StructPtrType>
InspectorIssueDetailsPtr InspectorIssueDetails::Clone() const {
  return New(
      mojo::Clone(sameSiteCookieIssueDetails)
  );
}

template <typename T, InspectorIssueDetails::EnableIfSame<T>*>
bool InspectorIssueDetails::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->sameSiteCookieIssueDetails, other_struct.sameSiteCookieIssueDetails))
    return false;
  return true;
}

template <typename T, InspectorIssueDetails::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<decltype(lhs.sameSiteCookieIssueDetails)>(lhs.sameSiteCookieIssueDetails, rhs.sameSiteCookieIssueDetails))
    return true;
  if (std::less<decltype(lhs.sameSiteCookieIssueDetails)>(rhs.sameSiteCookieIssueDetails, lhs.sameSiteCookieIssueDetails))
    return false;
  return false;
}
template <typename StructPtrType>
InspectorIssueInfoPtr InspectorIssueInfo::Clone() const {
  return New(
      mojo::Clone(code),
      mojo::Clone(details),
      mojo::Clone(resources)
  );
}

template <typename T, InspectorIssueInfo::EnableIfSame<T>*>
bool InspectorIssueInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->code, other_struct.code))
    return false;
  if (!mojo::Equals(this->details, other_struct.details))
    return false;
  if (!mojo::Equals(this->resources, other_struct.resources))
    return false;
  return true;
}

template <typename T, InspectorIssueInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<decltype(lhs.code)>(lhs.code, rhs.code))
    return true;
  if (std::less<decltype(lhs.code)>(rhs.code, lhs.code))
    return false;
  if (std::less<decltype(lhs.details)>(lhs.details, rhs.details))
    return true;
  if (std::less<decltype(lhs.details)>(rhs.details, lhs.details))
    return false;
  if (std::less<decltype(lhs.resources)>(lhs.resources, rhs.resources))
    return true;
  if (std::less<decltype(lhs.resources)>(rhs.resources, lhs.resources))
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AffectedCookie::DataView,
                                         ::blink::mojom::AffectedCookiePtr> {
  static bool IsNull(const ::blink::mojom::AffectedCookiePtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AffectedCookiePtr* output) { output->reset(); }

  static const decltype(::blink::mojom::AffectedCookie::name)& name(
      const ::blink::mojom::AffectedCookiePtr& input) {
    return input->name;
  }

  static const decltype(::blink::mojom::AffectedCookie::path)& path(
      const ::blink::mojom::AffectedCookiePtr& input) {
    return input->path;
  }

  static const decltype(::blink::mojom::AffectedCookie::domain)& domain(
      const ::blink::mojom::AffectedCookiePtr& input) {
    return input->domain;
  }

  static const decltype(::blink::mojom::AffectedCookie::site_for_cookies)& site_for_cookies(
      const ::blink::mojom::AffectedCookiePtr& input) {
    return input->site_for_cookies;
  }

  static bool Read(::blink::mojom::AffectedCookie::DataView input, ::blink::mojom::AffectedCookiePtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AffectedResources::DataView,
                                         ::blink::mojom::AffectedResourcesPtr> {
  static bool IsNull(const ::blink::mojom::AffectedResourcesPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AffectedResourcesPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::AffectedResources::cookies)& cookies(
      const ::blink::mojom::AffectedResourcesPtr& input) {
    return input->cookies;
  }

  static bool Read(::blink::mojom::AffectedResources::DataView input, ::blink::mojom::AffectedResourcesPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::SameSiteCookieIssueDetails::DataView,
                                         ::blink::mojom::SameSiteCookieIssueDetailsPtr> {
  static bool IsNull(const ::blink::mojom::SameSiteCookieIssueDetailsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::SameSiteCookieIssueDetailsPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::SameSiteCookieIssueDetails::exclusionReason)& exclusionReason(
      const ::blink::mojom::SameSiteCookieIssueDetailsPtr& input) {
    return input->exclusionReason;
  }

  static const decltype(::blink::mojom::SameSiteCookieIssueDetails::warningReason)& warningReason(
      const ::blink::mojom::SameSiteCookieIssueDetailsPtr& input) {
    return input->warningReason;
  }

  static bool Read(::blink::mojom::SameSiteCookieIssueDetails::DataView input, ::blink::mojom::SameSiteCookieIssueDetailsPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::InspectorIssueDetails::DataView,
                                         ::blink::mojom::InspectorIssueDetailsPtr> {
  static bool IsNull(const ::blink::mojom::InspectorIssueDetailsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::InspectorIssueDetailsPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::InspectorIssueDetails::sameSiteCookieIssueDetails)& sameSiteCookieIssueDetails(
      const ::blink::mojom::InspectorIssueDetailsPtr& input) {
    return input->sameSiteCookieIssueDetails;
  }

  static bool Read(::blink::mojom::InspectorIssueDetails::DataView input, ::blink::mojom::InspectorIssueDetailsPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::InspectorIssueInfo::DataView,
                                         ::blink::mojom::InspectorIssueInfoPtr> {
  static bool IsNull(const ::blink::mojom::InspectorIssueInfoPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::InspectorIssueInfoPtr* output) { output->reset(); }

  static decltype(::blink::mojom::InspectorIssueInfo::code) code(
      const ::blink::mojom::InspectorIssueInfoPtr& input) {
    return input->code;
  }

  static const decltype(::blink::mojom::InspectorIssueInfo::details)& details(
      const ::blink::mojom::InspectorIssueInfoPtr& input) {
    return input->details;
  }

  static const decltype(::blink::mojom::InspectorIssueInfo::resources)& resources(
      const ::blink::mojom::InspectorIssueInfoPtr& input) {
    return input->resources;
  }

  static bool Read(::blink::mojom::InspectorIssueInfo::DataView input, ::blink::mojom::InspectorIssueInfoPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_DEVTOOLS_INSPECTOR_ISSUE_MOJOM_H_