// third_party/blink/public/mojom/frame/media_player_action.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_MEDIA_PLAYER_ACTION_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_MEDIA_PLAYER_ACTION_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/frame/media_player_action.mojom-shared.h"
#include "third_party/blink/public/mojom/frame/media_player_action.mojom-forward.h"
#include <string>
#include <vector>




#include "third_party/blink/public/common/common_export.h"




namespace blink {
namespace mojom {





class BLINK_COMMON_EXPORT MediaPlayerAction {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<MediaPlayerAction, T>::value>;
  using DataView = MediaPlayerActionDataView;
  using Data_ = internal::MediaPlayerAction_Data;

  template <typename... Args>
  static MediaPlayerActionPtr New(Args&&... args) {
    return MediaPlayerActionPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static MediaPlayerActionPtr From(const U& u) {
    return mojo::TypeConverter<MediaPlayerActionPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, MediaPlayerAction>::Convert(*this);
  }


  MediaPlayerAction();

  MediaPlayerAction(
      MediaPlayerActionType type,
      bool enable);

  ~MediaPlayerAction();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = MediaPlayerActionPtr>
  MediaPlayerActionPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, MediaPlayerAction::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        MediaPlayerAction::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        MediaPlayerAction::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::MediaPlayerAction_UnserializedMessageContext<
            UserType, MediaPlayerAction::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<MediaPlayerAction::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return MediaPlayerAction::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::MediaPlayerAction_UnserializedMessageContext<
            UserType, MediaPlayerAction::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<MediaPlayerAction::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  MediaPlayerActionType type;
  
  bool enable;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, MediaPlayerAction::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, MediaPlayerAction::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, MediaPlayerAction::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, MediaPlayerAction::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
MediaPlayerActionPtr MediaPlayerAction::Clone() const {
  return New(
      mojo::Clone(type),
      mojo::Clone(enable)
  );
}

template <typename T, MediaPlayerAction::EnableIfSame<T>*>
bool MediaPlayerAction::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->enable, other_struct.enable))
    return false;
  return true;
}

template <typename T, MediaPlayerAction::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<decltype(lhs.type)>(lhs.type, rhs.type))
    return true;
  if (std::less<decltype(lhs.type)>(rhs.type, lhs.type))
    return false;
  if (std::less<decltype(lhs.enable)>(lhs.enable, rhs.enable))
    return true;
  if (std::less<decltype(lhs.enable)>(rhs.enable, lhs.enable))
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::MediaPlayerAction::DataView,
                                         ::blink::mojom::MediaPlayerActionPtr> {
  static bool IsNull(const ::blink::mojom::MediaPlayerActionPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::MediaPlayerActionPtr* output) { output->reset(); }

  static decltype(::blink::mojom::MediaPlayerAction::type) type(
      const ::blink::mojom::MediaPlayerActionPtr& input) {
    return input->type;
  }

  static decltype(::blink::mojom::MediaPlayerAction::enable) enable(
      const ::blink::mojom::MediaPlayerActionPtr& input) {
    return input->enable;
  }

  static bool Read(::blink::mojom::MediaPlayerAction::DataView input, ::blink::mojom::MediaPlayerActionPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_MEDIA_PLAYER_ACTION_MOJOM_H_